cwlVersion: v1.2
class: Workflow

requirements:
  ScatterFeatureRequirement: {}
  StepInputExpressionRequirement: {}
  InlineJavascriptRequirement: {}

inputs:
  IndexInput: File[]
  InputReadsMultipleSamples:
    type: 
      type: array
      items: 
        type: array
        items: File
  numCharsFastqFileName: int?
  isSingle: boolean
  FragmentLength: double?  
  StandardDeviation: double?
  BootstrapSamples: int?  

steps:
  index:
    run: kallisto-index.cwl
    in:
      InputFiles: IndexInput
      IndexName: 
        source: IndexInput
        valueFrom: $(self[0].nameroot)
    out: [index]
  quant:
    run: kallisto-quant.cwl
    scatter: 
      - InputReads
      - QuantOutfolder
    scatterMethod: dotproduct
    in:
      InputReads: InputReadsMultipleSamples
      QuantOutfolder:
        source: InputReadsMultipleSamples
        valueFrom: $(self[0].nameroot.substring(0,6))
      Index: index/index
      isSingle: isSingle
      FragmentLength: FragmentLength 
      StandardDeviation: StandardDeviation
      BootstrapSamples: BootstrapSamples
    out: [outFolder]

outputs:
  finalOut:
    type: Directory[]
    outputSource: quant/outFolder
